/*

    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>



#define VER     "0.1"
#define BUFFSZ  32768



int main(int argc, char *argv[]) {
    FILE            *fdin,
                    *fdout;
    unsigned char   buff[BUFFSZ];
    int             i,
                    len;


    setbuf(stdout, NULL);

    fputs("\n"
        "Binary files concatenator "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 3) {
        printf("\nUsage: %s <in_file1>...<in_fileN> <output_file>\n", argv[0]);
        exit(1);
    }

    argc--;
    fdout = fopen(argv[argc], "wb");
    if(!fdout) {
        perror("\nError");
        exit(1);
    }

    for(i = 1; i < argc; i++) {
        fdin = fopen(argv[i], "rb");
        if(!fdin) {
            printf("\nError: file %s doesn't exist!\n", argv[i]);
            continue;
        }

        while(!feof(fdin)) {
            len = fread(buff, 1, BUFFSZ, fdin);
            fwrite(buff, 1, len, fdout);
        }
        fclose(fdin);
        fputc('.', stdout);
    }

    fclose(fdout);
    fputc('\n', stdout);
    return(0);
}

